import { createApp } from 'vue'
import { createPinia } from 'pinia'
import { Quasar, Notify, Loading, Dialog } from 'quasar'
import { router } from './router/routes'
import AgtInput from './components/AgtInput.vue'
// Import icon libraries
import '@quasar/extras/material-icons/material-icons.css'
// Import Quasar css
import 'quasar/src/css/index.sass'

import './style.css'
import App from './App.vue'

const global = {
	LOCALE : {
		/* starting with Sunday */
		days: "일,월,화,수,목,금,토".split("_"),
		daysShort: "일 월 화 수 목 금 토".split(" "),
		months: "1월 2월 3월 4월 5월 6월 7월 8월 9월 10월 11월 12월".split(" "),
		monthsShort: "1월 2월 3월 4월 5월 6월 7월 8월 9월 10월 11월 12월".split(" "),
		firstDayOfWeek: 1, // 0-6, 0 - Sunday, 1 Monday, ...
		format24h: true,
		pluralDay: "dias",
	}
}

createApp(App)
	.component('agt-input', AgtInput)
	.use(createPinia())
	.use(router)
	.use(global)
	.use(Quasar, { plugins: [Notify, Loading, Dialog], configj: { Notify: {}, Loading: {}, Dialog: {} } })
	.mount('#app')
