
function groupArray (arr, ...keys) {
	keys.forEach(key => {
		if (arr[0] === undefined) return []
	})
	let ar = [];
	let result = arr.reduce(function (rv, x) {
		let compositKey = keys.reduce((r, item) => r += x[item] + '$', '');
		let exist = ar.find((item) => { return (item == compositKey) })
		if (!exist) ar.push(compositKey);
		(rv[compositKey] = rv[compositKey] || []).push(x);
		return rv;
	}, {})
	return ar.map((key) => {
		return result[key];
	})
}

function _log(...args) {
//	console.log(...args)
}

/*
 * 
 * 
 * @param {any} _rows 
 * @param {BASE_DATE: '2023-02-03', BY: TYPE/MODEL/LINE} options 
 * @returns {
 * 	title2
 * }
* */
function processData(_rows, options) {
	let retVal = {};
	if (_rows.length == 0) return;
	if (_rows[0].base_DT !=options. BASE_DATE) {
		return;
	}


	let banlist = options.BANS || [] // (localStorage.getItem('filteredClasses') || '').split(',');

	console.log(options)

	let filtered_rows = _rows.filter(row => !banlist.includes(row.type_CD));

	let nrow = []
	let field1 = 'line_NM', field2 = 'model_NM'

	if (options.BY == 'TYPE') {
		retVal.title2 = 'Model'
		field1 = 'type_NM'
		nrow = groupArray(filtered_rows, "type_CD", "model_CD", 'line_NO')
	} else if (options.BY == 'MODEL') {
		retVal.title2 ='Type'
		field1 = 'model_NM'
		field2 = 'type_NM'
		nrow = groupArray(filtered_rows, "model_CD", "type_CD", 'line_NO')
	} else {
		retVal.title2 = 'Model'
		nrow = groupArray(filtered_rows, "line_NO", "model_CD")
	}
	_log(nrow);
	let transposed_rows = nrow.reduce((r, xarr, idx) => {
		let arr = xarr[0];
//		let pLINE_NM = idx ? nrow[idx - 1][0][field1] : ""  // 현재 라인이름과 비교할 이전라인
		let newRow = { LINE_NO:arr.line_NO, LINE_NM: arr[field1], PREV_LINE_NM: '', ITEM_CD: arr[field2], ORDER_QTY: arr.prodt_ORDER_QTY, WORKER: arr.man_POWER, TIME: [0, 0, 0, 0, 0, 0], TOT: 0, BAL: 0, RATE: 0, BASE_DT: arr.base_DT, GET_TIME: arr.get_TIME.substring(0, 8) }
		xarr.forEach(x => {
			newRow.TIME[x.time_SEQ] += x.qty
			newRow.TOT += x.qty
		})
		newRow.BAL = newRow.TOT - newRow.ORDER_QTY;
		newRow.RATE = newRow.ORDER_QTY ? 100 * newRow.TOT / newRow.ORDER_QTY : 100
		r.push(newRow);
		return r;
	}, [])

	_log('transposed_rows', transposed_rows)

  let grouped_rows =	groupArray(transposed_rows, 'LINE_NM', 'ITEM_CD');
	_log('grouped_rows', grouped_rows)

	let group_merged_rows = grouped_rows.reduce((r, subarr, idx)=>{
			if (subarr.length == 1) r.push(subarr[0])
			else {
				let arr = subarr[0]
				let merged_row = { LINE_NO:arr.LINE_NO, LINE_NM: arr.LINE_NM, PREV_LINE_NM: '', ITEM_CD: arr.ITEM_CD, ORDER_QTY: 0, WORKER: arr.WORKER, TIME: [0, 0, 0, 0, 0, 0], TOT: 0, BAL: 0, RATE: 0, BASE_DT: arr.BASE_DT, GET_TIME: arr.GET_TIME }
				subarr.forEach((s, i)=>{
					merged_row.ORDER_QTY += s.ORDER_QTY;
					merged_row.TIME[0] += s.TIME[0];
					merged_row.TIME[1] += s.TIME[1];
					merged_row.TIME[2] += s.TIME[2];
					merged_row.TIME[3] += s.TIME[3];
					merged_row.TIME[4] += s.TIME[4];
					merged_row.TIME[5] += s.TIME[5];
					merged_row.TOT += s.TOT;
				})
				r.push(merged_row)
			}
			return r;
	},[])

	_log('group_merged_rows',group_merged_rows)

	let final_group_rows = groupArray(group_merged_rows, 'LINE_NM')

	_log('final_group_rows',final_group_rows)

	// 총합계 행 : totrow.value에 바이드될것임
	let grow = { ORDER_QTY: 0, TIME: [0, 0, 0, 0, 0, 0], TOT: 0, BAL: 0, RATE: 0 }

	let finalRows = final_group_rows.reduce((r, subarr, idx) => {
		if (subarr.length == 1) r.push(subarr[0])
		else {
			let subtot = { LINE_NM: subarr[0].LINE_NM, PREV_LINE_NM: subarr[0].LINE_NM, ITEM_CD: 'total', ORDER_QTY: 0, WORKER: '', TIME: [0, 0, 0, 0, 0, 0], TOT: 0, BAL: 0, RATE: 0, BASE_DT: '', GET_TIME: '' }
			subarr.forEach((s, i)=>{
				if (i==0) s.PREV_LINE_NM = ''
				else s.PREV_LINE_NM = s.LINE_NM
				r.push(s)
				subtot.ORDER_QTY += s.ORDER_QTY;
				subtot.TIME[0] += s.TIME[0];
				subtot.TIME[1] += s.TIME[1];
				subtot.TIME[2] += s.TIME[2];
				subtot.TIME[3] += s.TIME[3];
				subtot.TIME[4] += s.TIME[4];
				subtot.TIME[5] += s.TIME[5];
				subtot.TOT += s.TOT;
			})
			subtot.BAL = subtot.TOT - subtot.ORDER_QTY
			subtot.RATE = subtot.ORDER_QTY ? 100 * subtot.TOT / subtot.ORDER_QTY : 100
			r.push(subtot)
		}
		return r;
	}, [])

	_log('finalRows', finalRows)

	finalRows.forEach(s=>{
		if (s.ITEM_CD != 'total') {
			_log(s.ITEM_CD)
			grow.ORDER_QTY += s.ORDER_QTY;
			grow.TIME[0] += s.TIME[0];
			grow.TIME[1] += s.TIME[1];
			grow.TIME[2] += s.TIME[2];
			grow.TIME[3] += s.TIME[3];
			grow.TIME[4] += s.TIME[4];
			grow.TIME[5] += s.TIME[5];
			grow.TOT += s.TOT;
		}
	})
	grow.BAL = grow.TOT - grow.ORDER_QTY
	grow.RATE = grow.ORDER_QTY ? 100 * grow.TOT / grow.ORDER_QTY : 100
	retVal.total = grow
	retVal.data = finalRows
	return retVal
}


export const dataProcess = {
	groupArray,
	processData

}