import path from 'path'
import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'
import {quasar, transformAssetUrls } from '@quasar/vite-plugin'
// https://vitejs.dev/config/
export default defineConfig({
	server: {
		port: 8000,
		strictPort: true,
		host: true,
		proxy: {
		'/api': {
			target: 'http://agt.vjs.kr:8081',
			changeOrigin: true,
			rewrite: (path) => path.replace(/^\/api/, '/api/'),
			secure: false,
			ws: true
			}
		}
	},
  plugins: [
		vue({
			template: { transformAssetUrls }
		}),
		quasar({
			sassVariables: 'src/variables.sass'
		})],
})
